﻿/*
Built using Kango - Cross-browser extension framework
http://kangoextensions.com/
*/
function SEO() {
	var self = this;
	kango.ui.browserButton.setPopup({
		"url": "popup.html",
		"width": {
			chrome: 700,
			firefox: 700,
			opera: 700,
			safari: 700
		}[kango.browser.getName()],
		"height": {
			chrome: 560,
			firefox: 560,
			opera: 575,
			safari: 575
		}[kango.browser.getName()],
	});
	kango.browser.addEventListener('TabChanged', function(event){self._onTabChanged(event);});
	kango.browser.addEventListener('DocumentComplete', function(event){self._onTabChanged(event);});
	this.mprxmlhttp = kango.xhr.getXMLHttpRequest();
}

SEO.prototype = {
	bgcurrUrl: null,
	bgcurrFullUrl: null,
	bglastUrl: "",
	bglastFullUrl: "",
	wholeUrl: null,
	
	process: function(event){
		var tab = event.target;
		if (tab && tab.isActive()){
			var url = tab.getUrl();
			if (this.mprxmlhttp.readyState != 0){
				this.mprxmlhttp.abort();
			}
			this.getUrl(url)
		}
	},
	
	getUrl: function(url){
    this.wholeUrl = this.parseUri(url);
    if (!this.wholeUrl.relative) this.wholeUrl.relative = "";
    if (this.wholeUrl.relative == "%2F") this.wholeUrl.relative = "";
    this.bgcurrFullUrl = url;
    this.bgcurrUrl = this.getHost(url);
    var text = "";
    if (this.bgcurrUrl == "chrome:" || this.bgcurrUrl == "file:" || this.bgcurrUrl == "chrome-extension:" || this.bgcurrUrl == "view-source:http:" || this.bgcurrUrl == "view-source:https:") {
				kango.ui.browserButton.setBadgeValue("");
				kango.ui.browserButton.setTooltipText('');
        this.bglastUrl = this.bgcurrUrl;
        this.bglastFullUrl = this.bgcurrFullUrl
    } else {
				kango.storage.setItem('domainpr', 1);
        if (kango.storage.getItem('domainpr') && kango.storage.getItem('domainpr') == 1) {
						kango.ui.browserButton.setBadgeValue("");
            var ct = parseInt((new Date().getTime()) / 1000);
            this.googleRank();
            this.bglastFullUrl = this.bgcurrFullUrl
        } else {
						kango.ui.browserButton.setBadgeValue("");
            var ct = parseInt((new Date().getTime()) / 1000);
            if (kango.storage.getItem(this.bgcurrUrl) && (ct - kango.storage.getItem(this.bgcurrUrl + 't')) < 86400) {
                pr = kango.storage.getItem(this.bgcurrUrl);
								kango.ui.browserButton.setBadgeValue(pr);
                if (pr != 'n/a'){
									kango.ui.browserButton.setTooltipText("Google Pagerank: " + pr + "/10")
								} else {
									kango.ui.browserButton.setTooltipText("Google Pagerank: " + pr)
								}
            } else {
                if (kango.storage.getItem(this.bgcurrUrl)) {
                    kango.storage.removeItem(this.bgcurrUrl);
                    kango.storage.removeItem(this.bgcurrUrl + 't')
                }
                this.googleRank()
            }
            bglastUrl = this.bgcurrUrl
        }
    }
	},
	
	googleRank: function(){
    kango.storage.setItem('domainpr', 1);
    var workingURL = "";
		var self = this;
    if (kango.storage.getItem('domainpr') && kango.storage.getItem('domainpr') == 1) {
      var hash = this.awesomeHash(this.bgcurrFullUrl);
      workingURL = "http://toolbarqueries.google.com/tbr?client=navclient-auto&ch=8" + hash + "&features=Rank&q=info:" + escape(this.bgcurrFullUrl)
    } else {
      var hash = this.awesomeHash(this.bgcurrUrl);
      workingURL = "http://toolbarqueries.google.com/tbr?client=navclient-auto&ch=8" + hash + "&features=Rank&q=info:" + this.bgcurrUrl
    }
    this.mprxmlhttp = kango.xhr.getXMLHttpRequest();
    this.mprxmlhttp.onreadystatechange = function() {
			if (this.readyState == 4 && this.status == 200) {
				var rt = this.responseText;
				if (rt.indexOf('reload') >= 0) {
					self.googleRank();
					return
				}
				var pr = rt.substr(rt.lastIndexOf(':') + 1);
				pr = pr.substr(0, pr.length - 1);
				if (!self.isInt(pr) && pr != '0') {
						pr = 'n/a'
				}
				if (kango.storage.getItem('domainpr') && kango.storage.getItem('domainpr') == 1) {} else {
					kango.storage.setItem(this.bgcurrUrl, pr);
					kango.storage.setItem(this.bgcurrUrl+'t', parseInt((new Date().getTime()) / 1000));
				}
				kango.ui.browserButton.setBadgeValue(pr);
				if (pr != 'n/a'){
					kango.ui.browserButton.setTooltipText("Google Pagerank: " + pr + "/10")
				} else {
					kango.ui.browserButton.setTooltipText("Google Pagerank: " + pr)
				}
			}
    };
    this.mprxmlhttp.open("GET", workingURL, true);
    this.mprxmlhttp.send(null)
	},
	
	toHex8: function(b) {
    return (b < 16 ? "0" : "") + b.toString(16)
	},

	hexEncodeU32: function(b) {
    var c = this.toHex8(b >>> 24);
    c += this.toHex8(b >>> 16 & 255);
    c += this.toHex8(b >>> 8 & 255);
    return c + this.toHex8(b & 255)
	},

	awesomeHash: function(b) {
    for (var c = 16909125, d = 0; d < b.length; d++) {
        var HASH_SEED_ = "Mining PageRank is AGAINST GOOGLE'S TERMS OF SERVICE. Yes, I'm talking to you, scammer.";
        c ^= HASH_SEED_.charCodeAt(d % HASH_SEED_.length) ^ b.charCodeAt(d);
        c = c >>> 23 | c << 9
    }
    return this.hexEncodeU32(c)
	},
	
	getHost: function(url) {
    var host = url.replace(/^https{0,1}:\/\//, '');
    host = host.replace(/^www\./, '');
    host = host.replace(/^www[a-z,0-9,A-Z]\./, '');
    host = host.replace(/\/.*/, '');
    return host
	},
	isInt: function(num) {
			return (num.toString().search(/^-?[0-9,]+$/) == 0)
	},
	

	
	_parseUriOptions: {
			strictMode: !1,
			key: ["source", "protocol", "authority", "userInfo", "user", "password", "host", "port", "relative", "path", "directory", "file", "query", "anchor"],
			q: {
					name: "queryKey",
					parser: /(?:^|&)([^&=]*)=?([^&]*)/g
			},
			parser: {
					strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
					loose: /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
			}
	},
	parseUri: function(a) {
    var d = {};
    for (var b = this._parseUriOptions, a = b.parser[b.strictMode ? "strict" : "loose"].exec(a), d = {}, c = 14; c--;)
    d[b.key[c]] = encodeURIComponent(a[c]) == "undefined" ? "" : encodeURIComponent(a[c]);
    d[b.q.name] = {};
    decodeURIComponent(d[b.key[12]]).replace(b.q.parser, function(a, c, f) {
        c && (d[b.q.name][c] = encodeURIComponent(f));
        //		alert(f);
    });
    return d
	},

	/* browser related actions */
	_onCommand: function() {
		kango.browser.tabs.create({url: 'http://kangoextensions.com/'});
	},
	_onTabChanged: function(event){
		this.process(event);
	}
	
	
};

var extension = new SEO();